package models

import (
	"go.mongodb.org/mongo-driver/bson/bsontype"
	"go.mongodb.org/mongo-driver/bson/primitive"
)

//go:generate go run ../_gen/id-generate.go -- ids_gen.go

type EntityID interface {
	ObjID() (primitive.ObjectID, error)
	String() string
	MarshalBSONValue() (bsontype.Type, []byte, error)
	AsAny() AnyID
}

type AnyID string //@id:type

type OrgUserID string //@id:type

type AdminUserID string //@id:type

type AppUserID string //@id:type

type PostID string //@id:type

type CrawlerID string //@id:type

type CrawlerExecutionID string //@id:type

type CrawlerLogID string //@id:type

type BlobID string //@id:type

type ConversationNoteID string //@id:type

type PasswordResetTokenID string //@id:type

type OrganizationID string //@id:type

type GroupID string //@id:type

type FAPICallID string //@id:type

type SolseitAPICallID string //@id:type

type MigrationID string //@id:type

type EventID string //@id:type

type SolseitMappingID string //@id:type

type SolseitCommunityID string //@id:type

type JobLogID string //@id:type

type JobExecutionID string //@id:type

type SubscriptionID string //@id:type

type SMSVerificationID string //@id:type

type CommunityID string //@id:type

func (i AnyID) AsOrgUserID() OrgUserID {
	return OrgUserID(i)
}

func (i AnyID) AsGroupID() GroupID {
	return GroupID(i)
}

func (i AnyID) AsEventID() EventID {
	return EventID(i)
}

func (i AnyID) AsAppUserID() AppUserID {
	return AppUserID(i)
}
