package models

import "time"

type SolseitArticle struct {
	Id              int            // Artikelnummer
	Name            string         // Vorname des Autors
	Surname         string         // Nachname des Autors
	Date            string         // Erstellungszeitpunkt des Artikels
	Cw              string         // Kalenderwoche in welcher der Artikel erschienen ist/erscheinen wird. Format: Kalenderwoche/Jahreszahl zweistellig
	Comment         string         // Kommentar zum Artikel
	Headline        string         // Überschrift des Artikels
	Text            string         // Artikeltext
	RubricName      string         // Rubrik in welcher der Artikel erscheint. Wenn für die Rubrik ein alternativer Rubrikname gesetzt ist, wird dieser ausgeleitet
	RubricId        int            // Die Datenbank-ID der Rubrik
	CommunityName   string         // Gemeinde in welcher der Artikel erscheint
	CommunityId     int            // Die Datenbank-Id der Gemeinde in welcher der Artikel erscheint
	PublicationDate *time.Time     // Erscheinungsdatum des Artikels
	Online          bool           // Liefert eine 1 zurück, wenn der Artikel in SRC als 'online' markiert wurde
	LastModified    *time.Time     // Zeitstempel der letzten Veränderung des Artikels
	Images          []SolseitImage // Bilder des Artikels
}

type SolseitImage struct {
	ImagePath    string // URL zur Bilddatei
	ImageMeta    string // Metadaten zur Bilddatei, wie z.B. Dagteigröße, Format etc.
	ImageSubline string // Bildunterschrift
	ImageAuthor  string // Bildautor
}
